
require "grwin"

TRH = 0.4330127
PI = Math::PI

RX, RY = -0.5, -TRH
GX, GY = 0.0, TRH
BX, BY = 0.5, -TRH
ID, MX, ND = 0, 11, 256
A = 2.0
S = 'testmix'

ibc, IBS, IBH = 0, 1, 0
x1, x2 = 0.0,1.0

print <<EOM
Mix Mode:
    0:NOP
    1:BLACK
    2:WHITE
    3:NOT
    4:COPYPEN
    5:MASKPEN
    6:MERGEPEN
    7:XORPEN
    8:NOTCOPYPEN
    9:NOTMASKPEN
   10:NOTMERGEPEN
   11:NOTXORPEN
   12:MASKNOTPEN
   13:MASKPENNOT
   14:MERGENOTPEN
   15:MERGEPENNOT
EOM
print "Enter MIX mode (0-15): "

mx = gets.to_i

GrWin.init()
GrWin.openx(0, -1, -1, -1, -1, -1, S)
GrWin.vport(0.0,0.0,1.0,1.0)
llw, llh = GrWin.size(1, llw, llh)
lw,  lh  = GrWin.size(2, lw, lh)
lfw, lfh = GrWin.size(3, lfw, lfh)
lsw, lsh = GrWin.size(4, lsw, lsh)
print "   Size: #{llw} x #{llh}\n"
print "   View: #{lw} x #{lh}\n"
print "  Frame: #{lfw} x #{lfh}\n"
print " Screen: #{lsw} x #{lsh}\n"

GrWin.vport(0.0,0.0,1.0,1.0)
GrWin.window(-A*1.1, -A*1.1, A*1.1, A*1.1)
WH = 2.0 * A / ND
GrWin.mode(3, 0)

for iy in 0..ND-1
  y = iy * WH - A
  for ix in 0..ND-1
	x = ix * WH - A
	r = (x**2+y**2)**(0.3)
	ired = 256 * Math.sqrt((x-RX)**2+(y-RY)**2)*r
	ired = 255 if ired > 255
	igreen = 256 * Math.sqrt((x-GX)**2+(y-GY)**2)*r
	igreen = 255 if igreen > 255
	iblue = 256 * Math.sqrt((x-BX)**2+(y-BY)**2)*r
	iblue = 255 if iblue > 255
	#print ired, ' ', igreen, ' ', iblue, "\n"
	#p GrWin.krgb(ired,igreen,iblue)
	if ired+igreen+iblue < 3*255
	  GrWin.srect(x-WH/2,y-WH/2,x+WH/2,y+WH/2,
				  GrWin.krgb(ired,igreen,iblue))
	end	
  end
end

puts 'Drag mouse with L-button then R-button or R-button to quit'
GrWin.setpen(-1,-1,-1,mx)
while x1 != x2
  x1, y1, x2, y2 = GrWin.caprect('Drag mouse')
  ibc = ibc+1 % 36
  GrWin.setbrs(ibc, IBS, IBH)
  GrWin.ellipse(x1, y1, x2, y2)
end

print "(#{x1}, #{y1})\n"
GrWin.settxt(A*0.05, 0.0, -1, -1, -1, '')
GrWin.puttxt(x1, y1, S)
puts S

GrWin.quit
