
/*

  from 2001.07.14 Sat
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "GrWin.h"
#include "ruby.h"
/*#include "rubyio.h"*/

static VALUE mGrWin;

#define FILENAME_LENGTH_MAX 1024

static VALUE
rb_ext_GrWin_init(VALUE obj)
{
  return INT2FIX(GWinit());
}

static VALUE
rb_ext_GrWin_initx(VALUE obj, VALUE irb, VALUE ix, VALUE iy, VALUE iw, VALUE ih, VALUE ma, VALUE mm, VALUE mz)
{
  return INT2FIX(GWinitx(FIX2INT(irb), FIX2INT(ix), FIX2INT(iy), FIX2INT(iw), FIX2INT(ih), FIX2INT(ma), FIX2INT(mm), FIX2INT(mz)));
}

static VALUE
rb_ext_GrWin_quit(VALUE obj)
{
  return INT2FIX(GWquit());
}

static VALUE
rb_ext_GrWin_quitx(VALUE obj, VALUE mq)
{
  return INT2FIX(GWquitx(FIX2INT(mq)));
}

static VALUE
rb_ext_GrWin_open(VALUE obj, VALUE nw)
{
  return INT2FIX(GWopen(FIX2INT(nw)));
}

static VALUE
rb_ext_GrWin_openx(VALUE obj, VALUE nw, VALUE iw, VALUE ih, VALUE ifc, VALUE ibc, VALUE m, VALUE fn)
{
  return INT2FIX(GWopenx(FIX2INT(nw), FIX2INT(iw), FIX2INT(ih), FIX2INT(ifc), FIX2INT(ibc), FIX2INT(m), STR2CSTR(fn)));
}

static VALUE
rb_ext_GrWin_reset(VALUE obj)
{

  return INT2FIX(GWreset());
}

static VALUE
rb_ext_GrWin_close(VALUE obj, VALUE nw)
{

  return INT2FIX(GWclose(FIX2INT(nw)));
}

static VALUE
rb_ext_GrWin_window(VALUE obj, VALUE x1, VALUE y1, VALUE x2, VALUE y2)
{
  return INT2FIX(GWindow(NUM2DBL(x1), NUM2DBL(y1), NUM2DBL(x2), NUM2DBL(y2)));
}

static VALUE
rb_ext_GrWin_getwn(VALUE obj)
{
  float x1, y1, x2, y2;
  VALUE ary;

  GWgetwn(&x1, &y1, &x2, &y2);
  ary = rb_ary_new();
  rb_ary_push(ary, rb_float_new(x1));
  rb_ary_push(ary, rb_float_new(y1));
  rb_ary_push(ary, rb_float_new(x2));
  rb_ary_push(ary, rb_float_new(y2));
  return ary;
}

static VALUE
rb_ext_GrWin_vport(VALUE obj, VALUE u1, VALUE v1, VALUE u2, VALUE v2)
{
  return INT2FIX(GWvport(NUM2DBL(u1), NUM2DBL(v1), NUM2DBL(u2), NUM2DBL(v2)));
}

static VALUE
rb_ext_GrWin_port(VALUE obj, VALUE x1, VALUE y1, VALUE x2, VALUE y2)
{
  return INT2FIX(GWport(NUM2DBL(x1), NUM2DBL(y1), NUM2DBL(x2), NUM2DBL(y2)));
}

static VALUE
rb_ext_GrWin_getvp(VALUE obj)
{
  float u1, v1, u2, v2;
  VALUE ary;

  GWgetvp(&u1, &v1, &u2, &v2);
  ary = rb_ary_new();
  rb_ary_push(ary, rb_float_new(u1));
  rb_ary_push(ary, rb_float_new(v1));
  rb_ary_push(ary, rb_float_new(u2));
  rb_ary_push(ary, rb_float_new(v2));
  return ary;
}

static VALUE
rb_ext_GrWin_savevp(VALUE obj, VALUE ivp)
{
  return INT2FIX(GWsavevp(FIX2INT(ivp)));
}

static VALUE
rb_ext_GrWin_selvp(VALUE obj, VALUE ivp)
{
  return INT2FIX(GWselvp(FIX2INT(ivp)));
}

static VALUE
rb_ext_GrWin_first(VALUE obj)
{
  return INT2FIX(GWfirst());
}

static VALUE
rb_ext_GrWin_next(VALUE obj, VALUE nw)
{
  return INT2FIX(GWnext(FIX2INT(nw)));
}

static VALUE
rb_ext_GrWin_select(VALUE obj, VALUE nw)
{
  return INT2FIX(GWselect(FIX2INT(nw)));
}

static VALUE
rb_ext_GrWin_showwn(VALUE obj, VALUE nw, VALUE is)
{
  return INT2FIX(GWshowwn(FIX2INT(nw), FIX2INT(is)));
}

static VALUE
rb_ext_GrWin_showfr(VALUE obj, VALUE is)
{
  return INT2FIX(GWshowfr(FIX2INT(is)));
}

static VALUE
rb_ext_GrWin_arrange(VALUE obj, VALUE m)
{
  return INT2FIX(GWarrange(FIX2INT(m)));
}

static VALUE
rb_ext_GrWin_ldcpos(VALUE obj, VALUE x, VALUE y)
{
  int iu, iv;
  VALUE ary;

  GWldcpos(NUM2DBL(x), NUM2DBL(y), &iu, &iv);
  ary = rb_ary_new();
  rb_ary_push(ary, INT2FIX(iu));
  rb_ary_push(ary, INT2FIX(iv));
  return ary;
}

static VALUE
rb_ext_GrWin_ldcsiz(VALUE obj, VALUE w, VALUE h)
{
  int iu, iv;
  VALUE ary;

  GWldcsiz(NUM2DBL(w), NUM2DBL(h), &iu, &iv);
  ary = rb_ary_new();
  rb_ary_push(ary, INT2FIX(iu));
  rb_ary_push(ary, INT2FIX(iv));
  return ary;
}

static VALUE
rb_ext_GrWin_setpen(VALUE obj, VALUE ipc, VALUE ips, VALUE ipw, VALUE mx)
{
  return INT2FIX(GWsetpen(NUM2DBL(ipc), NUM2DBL(ips), NUM2DBL(ipw), NUM2DBL(mx)));
}

static VALUE
rb_ext_GrWin_getpen(VALUE obj)
{
  int ipc, ips, ipw, mx;
  VALUE ary;

  GWgetpen(&ipc, &ips, &ipw, &mx);
  ary = rb_ary_new();
  rb_ary_push(ary, INT2FIX(ipc));
  rb_ary_push(ary, INT2FIX(ips));
  rb_ary_push(ary, INT2FIX(ipw));
  rb_ary_push(ary, INT2FIX(mx));
  return ary;
}

static VALUE
rb_ext_GrWin_setbrs(VALUE obj, VALUE ibc, VALUE ibs, VALUE ibh)
{
  return INT2FIX(GWsetbrs(FIX2INT(ibc), FIX2INT(ibs), FIX2INT(ibh)));
}

static VALUE
rb_ext_GrWin_getbrs(VALUE obj)
{
  int ibc, ibs, ibh;
  VALUE ary;

  GWgetbrs(&ibc, &ibs, &ibh);
  ary = rb_ary_new();
  rb_ary_push(ary, INT2FIX(ibc));
  rb_ary_push(ary, INT2FIX(ibs));
  rb_ary_push(ary, INT2FIX(ibh));
  return ary;
}

static VALUE
rb_ext_GrWin_settxt(VALUE obj, VALUE h, VALUE a, VALUE io, VALUE k, VALUE kb, VALUE face)
{
  return INT2FIX(GWsettxt(NUM2DBL(h), NUM2DBL(a), FIX2INT(io), FIX2INT(k), FIX2INT(kb), STR2CSTR(face)));
}

static VALUE
rb_ext_GrWin_gettxt(VALUE obj, VALUE txt)
/*rb_ext_GrWin_gettxt(VALUE obj, VALUE v_w, VALUE v_h, VALUE v_x, VALUE v_y, VALUE txt)*/
{
  float w, h, x, y;
  VALUE ary;

#if 0
  w = (float)NUM2DBL(v_w); h = (float)NUM2DBL(v_h);
  x = (float)NUM2DBL(v_x); y = (float)NUM2DBL(v_y);
#endif
  GWgettxt(&w, &h, &x, &y, STR2CSTR(txt));
  ary = rb_ary_new();
  rb_ary_push(ary, rb_float_new(w));
  rb_ary_push(ary, rb_float_new(h));
  rb_ary_push(ary, rb_float_new(x));
  rb_ary_push(ary, rb_float_new(y));
  return ary;
}

static VALUE
rb_ext_GrWin_puttxt(VALUE obj, VALUE x, VALUE y, VALUE txt)
{
  return INT2FIX(GWputtxt(NUM2DBL(x), NUM2DBL(y), STR2CSTR(txt)));
}

static VALUE
rb_ext_GrWin_setsym(VALUE obj, VALUE h, VALUE a, VALUE io, VALUE k, VALUE kb, VALUE face)
{
  return INT2FIX(GWsetsym(NUM2DBL(h), NUM2DBL(a), FIX2INT(io), FIX2INT(k), FIX2INT(kb), STR2CSTR(face)));
}

static VALUE
rb_ext_GrWin_getsym(VALUE obj, VALUE ic)
{
  float w, h;
  VALUE ary;

  GWgetsym(&w, &h, FIX2INT(ic));
  ary = rb_ary_new();
  rb_ary_push(ary, rb_float_new(w));
  rb_ary_push(ary, rb_float_new(h));
  return ary;
}

static VALUE
rb_ext_GrWin_putsym(VALUE obj, VALUE x, VALUE y, VALUE ic)
{
  return INT2FIX(GWputsym(NUM2DBL(x), NUM2DBL(y), FIX2INT(ic)));
}

static VALUE
rb_ext_GrWin_setmsg(VALUE obj, VALUE txt)
{
  return INT2FIX(GWsetmsg(STR2CSTR(txt)));
}

static VALUE
rb_ext_GrWin_msgbox(VALUE obj, VALUE txt)
{
  return INT2FIX(GWmsgbox(STR2CSTR(txt)));
}

static VALUE
rb_ext_GrWin_getpos(VALUE obj)
{
  float x, y;
  VALUE ary;

  GWgetpos(&x, &y);
  ary = rb_ary_new();
  rb_ary_push(ary, rb_float_new(x));
  rb_ary_push(ary, rb_float_new(y));
  return ary;
}

static VALUE
rb_ext_GrWin_move2(VALUE obj, VALUE x, VALUE y)
{
  return INT2FIX(GWmove2(NUM2DBL(x), NUM2DBL(y)));
}

static VALUE
rb_ext_GrWin_line2(VALUE obj, VALUE x, VALUE y)
{
  return INT2FIX(GWline2(NUM2DBL(x), NUM2DBL(y)));
}

static VALUE
rb_ext_GrWin_line(VALUE obj, VALUE x1, VALUE y1, VALUE x2, VALUE y2)
{
  return INT2FIX(GWline(NUM2DBL(x1), NUM2DBL(y1), NUM2DBL(x2), NUM2DBL(y2)));
}

static VALUE
rb_ext_GrWin_rect(VALUE obj, VALUE x1, VALUE y1, VALUE x2, VALUE y2)
{
  return INT2FIX(GWrect(NUM2DBL(x1), NUM2DBL(y1), NUM2DBL(x2), NUM2DBL(y2)));
}

static VALUE
rb_ext_GrWin_srect(VALUE obj, VALUE x1, VALUE y1, VALUE x2, VALUE y2, VALUE k)
{
  return INT2FIX(GWsrect((float)NUM2DBL(x1), (float)NUM2DBL(y1), (float)NUM2DBL(x2), (float)NUM2DBL(y2), FIX2INT(k)));
}

static VALUE
rb_ext_GrWin_rrect(VALUE obj, VALUE x1, VALUE y1, VALUE x2, VALUE y2, VALUE w, VALUE h)
{
  return INT2FIX(GWrrect(NUM2DBL(x1), NUM2DBL(y1), NUM2DBL(x2), NUM2DBL(y2), NUM2DBL(w), NUM2DBL(h)));
}

static VALUE
rb_ext_GrWin_ellipse(VALUE obj, VALUE x1, VALUE y1, VALUE x2, VALUE y2)
{
  return INT2FIX(GWellipse(NUM2DBL(x1), NUM2DBL(y1), NUM2DBL(x2), NUM2DBL(y2)));
}

static VALUE
rb_ext_GrWin_arc(VALUE obj, VALUE x1, VALUE y1, VALUE x2, VALUE y2, VALUE a, VALUE aw)
{
  return INT2FIX(GWarc(NUM2DBL(x1), NUM2DBL(y1), NUM2DBL(x2), NUM2DBL(y2), NUM2DBL(a), NUM2DBL(aw)));
}

static VALUE
rb_ext_GrWin_chord(VALUE obj, VALUE x1, VALUE y1, VALUE x2, VALUE y2, VALUE a, VALUE aw)
{
  return INT2FIX(GWchord(NUM2DBL(x1), NUM2DBL(y1), NUM2DBL(x2), NUM2DBL(y2), NUM2DBL(a), NUM2DBL(aw)));
}

static VALUE
rb_ext_GrWin_pie(VALUE obj, VALUE x1, VALUE y1, VALUE x2, VALUE y2, VALUE a, VALUE aw)
{
  return INT2FIX(GWpie(NUM2DBL(x1), NUM2DBL(y1), NUM2DBL(x2), NUM2DBL(y2), NUM2DBL(a), NUM2DBL(aw)));
}

static VALUE
rb_ext_GrWin_polygon(VALUE obj, VALUE points, VALUE mf)
{
  int i, size;
  float *fptr;

  Check_Type(points, T_ARRAY);
  size = RARRAY(points)->len;
  if (size % 2 != 0) {
	rb_raise(rb_eArgError, "wrong # of arguments");
  }
  fptr = ALLOCA_N(float, size);
  for (i = 0; i < size; i++) {
	fptr[i] = (float)NUM2DBL(RARRAY(points)->ptr[i]);
  }
  return INT2FIX(GWpolygon(fptr, size / 2, FIX2INT(mf)));
}

static VALUE
rb_ext_GrWin_polylin(VALUE obj, VALUE points)
{
  int i, size;
  float *fptr;

  Check_Type(points, T_ARRAY);
  size = RARRAY(points)->len;
  if (size % 2 != 0) {
	rb_raise(rb_eArgError, "wrong # of arguments");
  }
  fptr = ALLOCA_N(float, size);
  for (i = 0; i < size; i++) {
	fptr[i] = (float)NUM2DBL(RARRAY(points)->ptr[i]);
  }
  return INT2FIX(GWpolylin(fptr, size / 2));
}

static VALUE
rb_ext_GrWin_bezier(VALUE obj, VALUE points)
{
  int i, size;
  float *fptr;

  Check_Type(points, T_ARRAY);
  size = RARRAY(points)->len;
  if ((size / 2) % 3 != 1) {
	rb_raise(rb_eArgError, "wrong # of arguments");
  }
  fptr = ALLOCA_N(float, size);
  for (i = 0; i < size; i++) {
	fptr[i] = (float)NUM2DBL(RARRAY(points)->ptr[i]);
  }
  return INT2FIX(GWbezier(fptr, size / 2));
}

static VALUE
rb_ext_GrWin_flood(VALUE obj, VALUE x, VALUE y)
{
  return INT2FIX(GWflood(NUM2DBL(x), NUM2DBL(y)));
}

static VALUE
rb_ext_GrWin_clear(VALUE obj, VALUE k)
{
  return INT2FIX(GWclear(FIX2INT(k)));
}

static VALUE
rb_ext_GrWin_setmrk(VALUE obj, VALUE mt, VALUE s, VALUE k, VALUE kb, VALUE mx)
{
  return INT2FIX(GWsetmrk(FIX2INT(mt), NUM2DBL(s), FIX2INT(k), FIX2INT(kb), FIX2INT(mx)));
}

static VALUE
rb_ext_GrWin_putmrk(VALUE obj, VALUE x, VALUE y)
{
  return INT2FIX(GWputmrk(NUM2DBL(x), NUM2DBL(y)));
}

static VALUE
rb_ext_GrWin_getmrk(VALUE obj)
{
  int mt, k, kb, mx;
  float s;
  VALUE ary;

  GWgetmrk(&mt, &s, &k, &kb, &mx);
  ary = rb_ary_new();
  rb_ary_push(ary, INT2FIX(mt));
  rb_ary_push(ary, rb_float_new(s));
  rb_ary_push(ary, INT2FIX(k));
  rb_ary_push(ary, INT2FIX(kb));
  rb_ary_push(ary, INT2FIX(mx));
  return ary;
}


static VALUE
rb_ext_GrWin_setxfrm(VALUE obj, VALUE xfrm)
{
  int i, size;
  float *fptr;

  Check_Type(xfrm, T_ARRAY);
  size = RARRAY(xfrm)->len;
  if (size != 6) {
	rb_raise(rb_eArgError, "wrong # of arguments");
  }
  fptr = ALLOCA_N(float, size);
  for (i = 0; i < size; i++) {
	fptr[i] = (float)NUM2DBL(RARRAY(xfrm)->ptr[i]);
  }
  return INT2FIX(GWsetxfrm(fptr));
}

static VALUE
rb_ext_GrWin_getxfrm(VALUE obj)
{
  int i;
  float xfrm[6];
  VALUE ary;

  GWgetxfrm(xfrm);
  ary = rb_ary_new();
  for (i = 0; i < 6; i++) {
	rb_ary_push(ary, rb_float_new(xfrm[i]));
  }
  return ary;
}

static VALUE
rb_ext_GrWin_setrgn(VALUE obj, VALUE x1, VALUE y1, VALUE x2, VALUE y2, VALUE m)
{
  return INT2FIX(GWsetrgn(NUM2DBL(x1), NUM2DBL(y1), NUM2DBL(x2), NUM2DBL(y2), FIX2INT(m)));
}

static VALUE
rb_ext_GrWin_setpxl(VALUE obj, VALUE x, VALUE y, VALUE k)
{
  return INT2FIX(GWsetpxl(NUM2DBL(x), NUM2DBL(y), FIX2INT(k)));
}

static VALUE
rb_ext_GrWin_getpxl(VALUE obj, VALUE x, VALUE y)
{
  return INT2FIX(GWgetpxl(NUM2DBL(x), NUM2DBL(y)));
}

static VALUE
rb_ext_GrWin_color(VALUE obj, VALUE k, VALUE idst)
{
  return INT2FIX(GWcolor(FIX2INT(k), FIX2INT(idst)));
}

static VALUE
rb_ext_GrWin_getrgb(VALUE obj, VALUE k)
{
  int ir, ig, ib;
  VALUE ary;

  GWgetrgb(FIX2INT(k), &ir, &ig, &ib);
  ary = rb_ary_new();
  rb_ary_push(ary, INT2FIX(ir));
  rb_ary_push(ary, INT2FIX(ig));
  rb_ary_push(ary, INT2FIX(ib));
  return ary;
}

static VALUE
rb_ext_GrWin_krgb(VALUE obj, VALUE ir, VALUE ig, VALUE ib)
{
  return INT2NUM(GWkrgb(NUM2INT(ir), NUM2INT(ig), NUM2INT(ib)));
}

static VALUE
rb_ext_GrWin_kcolor(VALUE obj, VALUE ic)
{
  return INT2FIX(GWkcolor(FIX2INT(ic)));
}

static VALUE
rb_ext_GrWin_ipalette(VALUE obj, VALUE ip)
{
  return INT2FIX(GWipalette(FIX2INT(ip)));
}

static VALUE
rb_ext_GrWin_ncolor(VALUE obj)
{

  return INT2FIX(GWncolor());
}

static VALUE
rb_ext_GrWin_savecc(VALUE obj, VALUE fn)
{
  return INT2FIX(GWsavecc(STR2CSTR(fn)));
}

static VALUE
rb_ext_GrWin_loadcc(VALUE obj, VALUE fn)
{
  return INT2FIX(GWloadcc(STR2CSTR(fn)));
}

static VALUE
rb_ext_GrWin_sysclr(VALUE obj, VALUE idx)
{
  return INT2FIX(GWsysclr(FIX2INT(idx)));
}

static VALUE
rb_ext_GrWin_cappnt(VALUE obj, VALUE text)
{
  float x, y;
  int ret;
  VALUE ary;

  ret = GWcappnt(&x, &y, STR2CSTR(text));
  ary = rb_ary_new();
  rb_ary_push(ary, INT2FIX(ret));
  rb_ary_push(ary, rb_float_new(x));
  rb_ary_push(ary, rb_float_new(y));
  return ary;
}

static VALUE
rb_ext_GrWin_capvec(VALUE obj, VALUE x1, VALUE y1, VALUE text)
{
  float x2, y2;
  int ret;
  VALUE ary;

  ret = GWcapvec(NUM2DBL(x1), NUM2DBL(y1), &x2, &y2, STR2CSTR(text));
  ary = rb_ary_new();
  rb_ary_push(ary, INT2FIX(ret));
  rb_ary_push(ary, rb_float_new(x2));
  rb_ary_push(ary, rb_float_new(y2));
  return ary;
}

static VALUE
rb_ext_GrWin_caplin(VALUE obj, VALUE text)
{
  float x1, y1, x2, y2;
  VALUE ary;

  GWcaplin(&x1, &y1, &x2, &y2, STR2CSTR(text));
  ary = rb_ary_new();
  rb_ary_push(ary, rb_float_new(x1));
  rb_ary_push(ary, rb_float_new(y1));
  rb_ary_push(ary, rb_float_new(x2));
  rb_ary_push(ary, rb_float_new(y2));
  return ary;
}

static VALUE
rb_ext_GrWin_caprect(VALUE obj, VALUE text)
{
  float x1, y1, x2, y2;
  VALUE ary;

  GWcaprect(&x1, &y1, &x2, &y2, STR2CSTR(text));
  ary = rb_ary_new();
  rb_ary_push(ary, rb_float_new(x1));
  rb_ary_push(ary, rb_float_new(y1));
  rb_ary_push(ary, rb_float_new(x2));
  rb_ary_push(ary, rb_float_new(y2));
  return ary;
}

static VALUE
rb_ext_GrWin_loadbmp(VALUE obj, VALUE nb, VALUE fn)
{
  return INT2FIX(GWloadbmp(FIX2INT(nb), STR2CSTR(fn)));
}

static VALUE
rb_ext_GrWin_savebmp(VALUE obj, VALUE nb, VALUE fn)
{
  return INT2FIX(GWsavebmp(FIX2INT(nb), STR2CSTR(fn)));
}

static VALUE
rb_ext_GrWin_makebmp(VALUE obj, VALUE nb, VALUE iw, VALUE ih, VALUE ibc, VALUE ibits)
{
  int i, size;
  int *iptr;

  Check_Type(ibits, T_ARRAY);
  size = RARRAY(ibits)->len;
  if (size != FIX2INT(iw) * FIX2INT(ih)) {
	rb_raise(rb_eArgError, "wrong # of arguments");
  }
  iptr = ALLOCA_N(int, size);
  for (i = 0; i < size; i++) {
	iptr[i] = FIX2INT(RARRAY(ibits)->ptr[i]);
  }
  return INT2FIX(GWmakebmp(FIX2INT(nb), FIX2INT(iw), FIX2INT(ih), FIX2INT(ibc), iptr));
}

static VALUE
rb_ext_GrWin_fnt2bmp(VALUE obj, VALUE nb, VALUE iw, VALUE ih, VALUE iu, VALUE iv, VALUE text)
{
  return INT2FIX(GWfnt2bmp(FIX2INT(nb), FIX2INT(iw), FIX2INT(ih), FIX2INT(iu), FIX2INT(iv), STR2CSTR(text)));
}

static VALUE
rb_ext_GrWin_setbmp(VALUE obj, VALUE nb, VALUE w, VALUE h, VALUE mx, VALUE itr, VALUE iof)
{
  return INT2FIX(GWsetbmp(FIX2INT(nb), NUM2DBL(w), NUM2DBL(h), FIX2INT(mx), FIX2INT(itr), FIX2INT(iof)));
}

static VALUE
rb_ext_GrWin_getbmp(VALUE obj, VALUE nb)
{
  float w, h;
  int iw, ih, nc, maxnb;
  char fn[FILENAME_LENGTH_MAX];
  VALUE ary;

  GWgetbmp(FIX2INT(nb), &w, &h, &iw, &ih, &nc, &maxnb, fn, FILENAME_LENGTH_MAX);
  ary = rb_ary_new();
  rb_ary_push(ary, rb_float_new(w));
  rb_ary_push(ary, rb_float_new(h));
  rb_ary_push(ary, INT2FIX(iw));
  rb_ary_push(ary, INT2FIX(ih));
  rb_ary_push(ary, INT2FIX(nc));
  rb_ary_push(ary, INT2FIX(maxnb));
  rb_ary_push(ary, rb_str_new2(fn));
  return ary;
}

static VALUE
rb_ext_GrWin_putbmp(VALUE obj, VALUE nb, VALUE x, VALUE y, VALUE ibk)
{
  return INT2FIX(GWputbmp(FIX2INT(nb), NUM2DBL(x), NUM2DBL(y), FIX2INT(ibk)));
}

static VALUE
rb_ext_GrWin_copybmp(VALUE obj, VALUE nb1, VALUE nb2)
{
  return INT2FIX(GWcopybmp(FIX2INT(nb1), FIX2INT(nb2)));
}

static VALUE
rb_ext_GrWin_capimg(VALUE obj, VALUE nb, VALUE x1, VALUE y1, VALUE x2, VALUE y2)
{
  return INT2FIX(GWcapimg(FIX2INT(nb), NUM2DBL(x1), NUM2DBL(y1), NUM2DBL(x2), NUM2DBL(y2)));
}

static VALUE
rb_ext_GrWin_clipimg(VALUE obj, VALUE x1, VALUE y1, VALUE x2, VALUE y2)
{
  return INT2FIX(GWclipimg(NUM2DBL(x1), NUM2DBL(y1), NUM2DBL(x2), NUM2DBL(y2)));
}

static VALUE
rb_ext_GrWin_loadcmb(VALUE obj, VALUE nm, VALUE fn)
{
  return INT2FIX(GWloadcmb(FIX2INT(nm), STR2CSTR(fn)));
}

static VALUE
rb_ext_GrWin_savecmb(VALUE obj, VALUE nm, VALUE fn)
{
  return INT2FIX(GWsavecmb(FIX2INT(nm), STR2CSTR(fn)));
}

static VALUE
rb_ext_GrWin_cmbmrk(VALUE obj, VALUE nm, VALUE mt, VALUE s, VALUE k, VALUE kb, VALUE mx)
{
  return INT2FIX(GWcmbmrk(FIX2INT(nm), FIX2INT(mt), NUM2DBL(s), FIX2INT(k), FIX2INT(kb), FIX2INT(mx)));
}

static VALUE
rb_ext_GrWin_begincmb(VALUE obj, VALUE nm, VALUE w, VALUE h)
{
  return INT2FIX(GWbegincmb(FIX2INT(nm), NUM2DBL(w), NUM2DBL(h)));
}

static VALUE
rb_ext_GrWin_endcmb(VALUE obj)
{
  return INT2FIX(GWendcmb());
}

static VALUE
rb_ext_GrWin_putcmb(VALUE obj, VALUE nm, VALUE x, VALUE y, VALUE w, VALUE h, VALUE iof)
{
  return INT2FIX(GWputcmb(FIX2INT(nm), NUM2DBL(x), NUM2DBL(y), NUM2DBL(w), NUM2DBL(h), FIX2INT(iof)));
}

static VALUE
rb_ext_GrWin_getcmb(VALUE obj, VALUE nm)
{
  float w, h, w0, h0;
  int maxnm;
  char fn[FILENAME_LENGTH_MAX];
  VALUE ary;

  GWgetcmb(FIX2INT(nm), &w, &h, &w0, &h0, &maxnm, fn, FILENAME_LENGTH_MAX);
  ary = rb_ary_new();
  rb_ary_push(ary, rb_float_new(w));
  rb_ary_push(ary, rb_float_new(h));
  rb_ary_push(ary, rb_float_new(w0));
  rb_ary_push(ary, rb_float_new(h0));
  rb_ary_push(ary, INT2FIX(maxnm));
  rb_ary_push(ary, rb_str_new2(fn));
  return ary;
}

static VALUE
rb_ext_GrWin_copycmb(VALUE obj, VALUE nm1, VALUE nm2)
{
  return INT2FIX(GWcopycmb(FIX2INT(nm1), FIX2INT(nm2)));
}

static VALUE
rb_ext_GrWin_delcmb(VALUE obj, VALUE nm)
{
  return INT2FIX(GWdelcmb(FIX2INT(nm)));
}

static VALUE
rb_ext_GrWin_filedlg(VALUE obj, VALUE v_fn)
{
  char fn[FILENAME_LENGTH_MAX];
  int ret;
  VALUE ary;

  ret = GWfiledlg(fn, FILENAME_LENGTH_MAX);
  ary = rb_ary_new();
  rb_ary_push(ary, INT2FIX(ret));
  rb_ary_push(ary, rb_str_new2(fn));
  return ary;
}

static VALUE
rb_ext_GrWin_load(VALUE obj, VALUE ic, VALUE fn)
{
  return INT2FIX(GWload(FIX2INT(ic), STR2CSTR(fn)));
}

static VALUE
rb_ext_GrWin_saveas(VALUE obj, VALUE mf, VALUE mv, VALUE iw, VALUE ih, VALUE fn)
{
  return INT2FIX(GWsaveas(FIX2INT(mf), FIX2INT(mv), FIX2INT(iw), FIX2INT(ih), STR2CSTR(fn)));
}

static VALUE
rb_ext_GrWin_print(VALUE obj, VALUE iw)
{
  return INT2FIX(GWprint(FIX2INT(iw)));
}

static VALUE
rb_ext_GrWin_input(VALUE obj, VALUE title)
{
  char txt[FILENAME_LENGTH_MAX];
  VALUE ary;

  GWinput(STR2CSTR(title), txt, FILENAME_LENGTH_MAX);
  return rb_str_new2(txt);
}

static VALUE
rb_ext_GrWin_kybrd(VALUE obj, VALUE m)
{
  int ich, ncnt, iflg;
  int ret;
  VALUE ary;

  ret = GWkybrd(&ich, &ncnt, &iflg, FIX2INT(m));
  ary = rb_ary_new();
  rb_ary_push(ary, INT2FIX(ret));
  rb_ary_push(ary, INT2FIX(ich));
  rb_ary_push(ary, INT2FIX(ncnt));
  rb_ary_push(ary, INT2FIX(iflg));
  return ary;
}

static VALUE
rb_ext_GrWin_mouse(VALUE obj)
{
  int irb;
  int ret;
  float x, y;
  VALUE ary;

  ret = GWmouse(&irb, &x, &y);
  ary = rb_ary_new();
  rb_ary_push(ary, INT2FIX(ret));
  rb_ary_push(ary, INT2FIX(irb));
  rb_ary_push(ary, rb_float_new(x));
  rb_ary_push(ary, rb_float_new(y));
  return ary;
}

static VALUE
rb_ext_GrWin_evnet(VALUE obj)
{
  float x, y;
  VALUE ary;

  GWevent(&x, &y);
  ary = rb_ary_new();
  rb_ary_push(ary, rb_float_new(x));
  rb_ary_push(ary, rb_float_new(y));
  return ary;
}

static VALUE
rb_ext_GrWin_idle(VALUE obj, VALUE msec)
{
  int ich;
  float x, y;
  VALUE ary;

  GWidle(&ich, &x, &y, FIX2INT(msec));
  ary = rb_ary_new();
  rb_ary_push(ary, INT2FIX(ich));
  rb_ary_push(ary, rb_float_new(x));
  rb_ary_push(ary, rb_float_new(y));
  return ary;
}

static VALUE
rb_ext_GrWin_idle2(VALUE obj, VALUE msec)
{
  int ich;
  float x, y;
  VALUE ary;

  GWidle2(&ich, &x, &y, FIX2INT(msec));
  ary = rb_ary_new();
  rb_ary_push(ary, INT2FIX(ich));
  rb_ary_push(ary, rb_float_new(x));
  rb_ary_push(ary, rb_float_new(y));
  return ary;
}

static VALUE
rb_ext_GrWin_sleep(VALUE obj, VALUE ms)
{
  return INT2FIX(GWsleep(FIX2INT(ms)));
}

static VALUE
rb_ext_GrWin_sleep2(VALUE obj, VALUE ms)
{
  return INT2FIX(GWsleep2(FIX2INT(ms)));
}

static VALUE
rb_ext_GrWin_pause(VALUE obj, VALUE txt)
{
  return INT2FIX(GWpause(STR2CSTR(txt)));
}

static VALUE
rb_ext_GrWin_setogn(VALUE obj, VALUE isrc, VALUE idst)
{
  return INT2FIX(GWsetogn(FIX2INT(isrc), FIX2INT(idst)));
}

static VALUE
rb_ext_GrWin_anchor(VALUE obj, VALUE n)
{
  return INT2FIX(GWanchor(FIX2INT(n)));
}

static VALUE
rb_ext_GrWin_setbk(VALUE obj, VALUE n)
{
  return INT2FIX(GWsetbk(FIX2INT(n)));
}

static VALUE
rb_ext_GrWin_erase(VALUE obj, VALUE n, VALUE lrf)
{
  return INT2FIX(GWerase(FIX2INT(n), FIX2INT(lrf)));
}

static VALUE
rb_ext_GrWin_flush(VALUE obj, VALUE n)
{
  return INT2FIX(GWflush(FIX2INT(n)));
}

static VALUE
rb_ext_GrWin_refresh(VALUE obj)
{
  return INT2FIX(GWrefresh());
}

static VALUE
rb_ext_GrWin_vwmod(VALUE obj, VALUE m)
{
  return INT2FIX(GWvwmod(FIX2INT(m)));
}

static VALUE
rb_ext_GrWin_mode(VALUE obj, VALUE md, VALUE m)
{
  return INT2FIX(GWmode(FIX2INT(md), FIX2INT(m)));
}

static VALUE
rb_ext_GrWin_size(VALUE obj, VALUE n, VALUE v_iw, VALUE v_ih)
{
  int iw, ih;
  VALUE ary;

  iw = FIX2INT(v_iw); ih = FIX2INT(v_ih);
  GWsize(FIX2INT(n), &iw, &ih);
  ary = rb_ary_new();
  rb_ary_push(ary, INT2FIX(iw));
  rb_ary_push(ary, INT2FIX(ih));
  return ary;
}

static VALUE
rb_ext_GrWin_aspect(VALUE obj, VALUE n)
{
  return INT2FIX(GWaspect(FIX2INT(n)));
}

static VALUE
rb_ext_GrWin_fmax(VALUE obj)
{
  return rb_float_new(GWfmax());
}


static VALUE
rb_ext_GrWin_version(VALUE obj, VALUE is)
{
  char str[FILENAME_LENGTH_MAX];
  VALUE ary;

  GWversion(FIX2INT(is), str, FILENAME_LENGTH_MAX);
  return rb_str_new2(str);
}

static VALUE
rb_ext_GrWin_kbhit(VALUE obj)
{
  return INT2FIX(kbhit());
}

static VALUE
rb_ext_GrWin_kbgetch(VALUE obj, VALUE n)
{
  return INT2FIX(kbgetch(n));
}

void
Init_grwin(){

  mGrWin = rb_define_module("GrWin");

  rb_define_module_function(mGrWin, "init", rb_ext_GrWin_init, 0);
  rb_define_module_function(mGrWin, "initx", rb_ext_GrWin_initx, 8);
  rb_define_module_function(mGrWin, "quit", rb_ext_GrWin_quit, 0);
  rb_define_module_function(mGrWin, "quitx", rb_ext_GrWin_quitx, 1);
  rb_define_module_function(mGrWin, "open", rb_ext_GrWin_open, 1);
  rb_define_module_function(mGrWin, "openx", rb_ext_GrWin_openx, 7);
  rb_define_module_function(mGrWin, "reset", rb_ext_GrWin_reset, 0);
  rb_define_module_function(mGrWin, "close", rb_ext_GrWin_close, 0);
  rb_define_module_function(mGrWin, "window", rb_ext_GrWin_window, 4);
  rb_define_module_function(mGrWin, "getwn", rb_ext_GrWin_getwn, 0);
  rb_define_module_function(mGrWin, "vport", rb_ext_GrWin_vport, 4);
  rb_define_module_function(mGrWin, "port", rb_ext_GrWin_port, 4);
  rb_define_module_function(mGrWin, "getvp", rb_ext_GrWin_getvp, 0);
  rb_define_module_function(mGrWin, "savevp", rb_ext_GrWin_savevp, 1);
  rb_define_module_function(mGrWin, "selvp", rb_ext_GrWin_selvp, 1);
  rb_define_module_function(mGrWin, "first", rb_ext_GrWin_first, 0);
  rb_define_module_function(mGrWin, "next", rb_ext_GrWin_next, 1);
  rb_define_module_function(mGrWin, "select", rb_ext_GrWin_select, 1);
  rb_define_module_function(mGrWin, "showwn", rb_ext_GrWin_showwn, 2);
  rb_define_module_function(mGrWin, "showfr", rb_ext_GrWin_showfr, 1);
  rb_define_module_function(mGrWin, "arrange", rb_ext_GrWin_arrange, 1);
  rb_define_module_function(mGrWin, "ldcpos", rb_ext_GrWin_ldcpos, 2);
  rb_define_module_function(mGrWin, "ldcsiz", rb_ext_GrWin_ldcsiz, 2);
  rb_define_module_function(mGrWin, "setpen", rb_ext_GrWin_setpen, 4);
  rb_define_module_function(mGrWin, "getpen", rb_ext_GrWin_getpen, 0);
  rb_define_module_function(mGrWin, "setbrs", rb_ext_GrWin_setbrs, 3);
  rb_define_module_function(mGrWin, "getbrs", rb_ext_GrWin_getbrs, 0);
  rb_define_module_function(mGrWin, "settxt", rb_ext_GrWin_settxt, 6);
  rb_define_module_function(mGrWin, "gettxt", rb_ext_GrWin_gettxt, 1);
  rb_define_module_function(mGrWin, "puttxt", rb_ext_GrWin_puttxt, 3);
  rb_define_module_function(mGrWin, "setsym", rb_ext_GrWin_setsym, 6);
  rb_define_module_function(mGrWin, "getsym", rb_ext_GrWin_getsym, 1);
  rb_define_module_function(mGrWin, "putsym", rb_ext_GrWin_putsym, 3);
  rb_define_module_function(mGrWin, "setmsg", rb_ext_GrWin_setmsg, 1);
  rb_define_module_function(mGrWin, "msgbox", rb_ext_GrWin_msgbox, 1);
  rb_define_module_function(mGrWin, "getpos", rb_ext_GrWin_getpos, 0);
  rb_define_module_function(mGrWin, "move2", rb_ext_GrWin_move2, 2);
  rb_define_module_function(mGrWin, "line2", rb_ext_GrWin_line2, 2);
  rb_define_module_function(mGrWin, "line", rb_ext_GrWin_line, 4);
  rb_define_module_function(mGrWin, "rect", rb_ext_GrWin_rect, 4);
  rb_define_module_function(mGrWin, "srect", rb_ext_GrWin_srect, 5);
  rb_define_module_function(mGrWin, "rrect", rb_ext_GrWin_rrect, 6);
  rb_define_module_function(mGrWin, "ellipse", rb_ext_GrWin_ellipse, 4);
  rb_define_module_function(mGrWin, "arc", rb_ext_GrWin_arc, 6);
  rb_define_module_function(mGrWin, "chord", rb_ext_GrWin_chord, 6);
  rb_define_module_function(mGrWin, "pie", rb_ext_GrWin_pie, 6);
  rb_define_module_function(mGrWin, "polygon", rb_ext_GrWin_polygon, 2);
  rb_define_module_function(mGrWin, "polylin", rb_ext_GrWin_polylin, 1);
  rb_define_module_function(mGrWin, "bezier", rb_ext_GrWin_bezier, 1);
  rb_define_module_function(mGrWin, "flood", rb_ext_GrWin_flood, 2);
  rb_define_module_function(mGrWin, "clear", rb_ext_GrWin_clear, 1);
  rb_define_module_function(mGrWin, "setmrk", rb_ext_GrWin_setmrk, 5);
  rb_define_module_function(mGrWin, "putmrk", rb_ext_GrWin_putmrk, 2);
  rb_define_module_function(mGrWin, "getmrk", rb_ext_GrWin_getmrk, 0);
  rb_define_module_function(mGrWin, "setxfrm", rb_ext_GrWin_setxfrm, 1);
  rb_define_module_function(mGrWin, "getxfrm", rb_ext_GrWin_getxfrm, 0);
  rb_define_module_function(mGrWin, "setrgn", rb_ext_GrWin_setrgn, 5);
  rb_define_module_function(mGrWin, "setpxl", rb_ext_GrWin_setpxl, 3);
  rb_define_module_function(mGrWin, "getpxl", rb_ext_GrWin_getpxl, 2);
  rb_define_module_function(mGrWin, "color", rb_ext_GrWin_color, 2);
  rb_define_module_function(mGrWin, "getrgb", rb_ext_GrWin_getrgb, 1);
  rb_define_module_function(mGrWin, "krgb", rb_ext_GrWin_krgb, 3);
  rb_define_module_function(mGrWin, "kcolor", rb_ext_GrWin_kcolor, 1);
  rb_define_module_function(mGrWin, "ipalette", rb_ext_GrWin_ipalette, 1);
  rb_define_module_function(mGrWin, "ncolor", rb_ext_GrWin_ncolor, 0);
  rb_define_module_function(mGrWin, "savecc", rb_ext_GrWin_savecc, 1);
  rb_define_module_function(mGrWin, "loadcc", rb_ext_GrWin_loadcc, 1);
  rb_define_module_function(mGrWin, "sysclr", rb_ext_GrWin_sysclr, 1);
  rb_define_module_function(mGrWin, "cappnt", rb_ext_GrWin_cappnt, 1);
  rb_define_module_function(mGrWin, "capvec", rb_ext_GrWin_capvec, 3);
  rb_define_module_function(mGrWin, "caplin", rb_ext_GrWin_caplin, 1);
  rb_define_module_function(mGrWin, "caprect", rb_ext_GrWin_caprect, 1);
  rb_define_module_function(mGrWin, "loadbmp", rb_ext_GrWin_loadbmp, 2);
  rb_define_module_function(mGrWin, "savebmp", rb_ext_GrWin_savebmp, 2);
  rb_define_module_function(mGrWin, "makebmp", rb_ext_GrWin_makebmp, 5);
  rb_define_module_function(mGrWin, "fnt2bmp", rb_ext_GrWin_fnt2bmp, 6);
  rb_define_module_function(mGrWin, "setbmp", rb_ext_GrWin_setbmp, 6);
  rb_define_module_function(mGrWin, "getbmp", rb_ext_GrWin_getbmp, 1);
  rb_define_module_function(mGrWin, "putbmp", rb_ext_GrWin_putbmp, 4);
  rb_define_module_function(mGrWin, "copybmp", rb_ext_GrWin_copybmp, 2);
  rb_define_module_function(mGrWin, "capimg", rb_ext_GrWin_capimg, 5);
  rb_define_module_function(mGrWin, "clipimg", rb_ext_GrWin_clipimg, 4);
  rb_define_module_function(mGrWin, "loadcmb", rb_ext_GrWin_loadcmb, 2);
  rb_define_module_function(mGrWin, "savecmb", rb_ext_GrWin_savecmb, 2);
  rb_define_module_function(mGrWin, "cmbmrk", rb_ext_GrWin_cmbmrk, 6);
  rb_define_module_function(mGrWin, "begincmb", rb_ext_GrWin_begincmb, 3);
  rb_define_module_function(mGrWin, "endcmb", rb_ext_GrWin_endcmb, 0);
  rb_define_module_function(mGrWin, "putcmb", rb_ext_GrWin_putcmb, 6);
  rb_define_module_function(mGrWin, "getcmb", rb_ext_GrWin_getcmb, 1);
  rb_define_module_function(mGrWin, "copycmb", rb_ext_GrWin_copycmb, 2);
  rb_define_module_function(mGrWin, "delcmb", rb_ext_GrWin_delcmb, 1);
  rb_define_module_function(mGrWin, "filedlg", rb_ext_GrWin_filedlg, 1);
  rb_define_module_function(mGrWin, "load", rb_ext_GrWin_load, 2);
  rb_define_module_function(mGrWin, "save", rb_ext_GrWin_saveas, 5);
  rb_define_module_function(mGrWin, "print", rb_ext_GrWin_print, 1);
  rb_define_module_function(mGrWin, "input", rb_ext_GrWin_input, 1);
  rb_define_module_function(mGrWin, "kybrd", rb_ext_GrWin_kybrd, 1);
  rb_define_module_function(mGrWin, "mouse", rb_ext_GrWin_mouse, 0);
  rb_define_module_function(mGrWin, "evnet", rb_ext_GrWin_evnet, 0);
  rb_define_module_function(mGrWin, "idle", rb_ext_GrWin_idle, 1);
  rb_define_module_function(mGrWin, "idle2", rb_ext_GrWin_idle2, 1);
  rb_define_module_function(mGrWin, "sleep", rb_ext_GrWin_sleep, 1);
  rb_define_module_function(mGrWin, "sleep2", rb_ext_GrWin_sleep2, 1);
  rb_define_module_function(mGrWin, "pause", rb_ext_GrWin_pause, 1);
  rb_define_module_function(mGrWin, "setogn", rb_ext_GrWin_setogn, 2);
  rb_define_module_function(mGrWin, "anchor", rb_ext_GrWin_anchor, 1);
  rb_define_module_function(mGrWin, "setbk", rb_ext_GrWin_setbk, 1);
  rb_define_module_function(mGrWin, "erase", rb_ext_GrWin_erase, 2);
  rb_define_module_function(mGrWin, "flush", rb_ext_GrWin_flush, 1);
  rb_define_module_function(mGrWin, "refresh", rb_ext_GrWin_refresh, 0);
  rb_define_module_function(mGrWin, "vwmod", rb_ext_GrWin_vwmod, 1);
  rb_define_module_function(mGrWin, "mode", rb_ext_GrWin_mode, 2);
  rb_define_module_function(mGrWin, "size", rb_ext_GrWin_size, 3);
  rb_define_module_function(mGrWin, "aspect", rb_ext_GrWin_aspect, 1);
  rb_define_module_function(mGrWin, "fmax", rb_ext_GrWin_fmax, 0);
  rb_define_module_function(mGrWin, "version", rb_ext_GrWin_version, 1);
  rb_define_module_function(mGrWin, "kbhit", rb_ext_GrWin_kbhit, 0);
  rb_define_module_function(mGrWin, "kbgetch", rb_ext_GrWin_kbgetch, 1);
}
